import numpy as np
import matplotlib.pyplot as plt
import copy

SZ = 100
fa = [0] * SZ


def Root(u):
    if fa[u] == 0:
        return u
    else:
        fa[u] = Root(fa[u])
        return fa[u]


def Merge(u, v):
    u = Root(u)
    v = Root(v)
    if u != v:
        fa[u] = v


class star:
    m = 0
    p, v = np.array([0, 0])
    col = ''

    def __init__(self, im=0, ip=np.array([0, 0]), iv=np.array([0, 0]), icol = ''):
        self.m = im
        self.p = ip
        self.v = iv
        self.col = icol


G = 6.6743e-11
DT = 100
R = 5e6

s = [star(1e23, np.array([0, 0]), np.array([20, 0]), 'r'),
    star(1e23, np.array([1e10, 1e10]), np.array([0, -10]), 'g'),
    star(1e23, np.array([998244353, 1e9+7]), np.array([-10, 10]), 'b')]

# plt.ion()
ps = copy.deepcopy(s)
T = 0
while T <= 1e5:
    sv = [np.array([0, 0]) for i in range(len(s))]
    for i in range(len(s)):
        for j in range(len(s)):
            if i == j:
                continue
            # i -> j
            d = s[j].p - s[i].p
            r = np.linalg.norm(d)
            f = G * s[i].m * s[j].m / r / r
            a = f / s[i].m
            sv[i] = sv[i] + DT * d / r * a

    for i in range(len(s)):
        s[i].p = s[i].p + DT * s[i].v + DT / 2 * sv[i]
        s[i].v = s[i].v + sv[i]

    fa = [0] * SZ

    for i in range(len(s)):
        for j in range(len(s)):
            if i == j:
                continue
            r = np.linalg.norm(s[i].p - s[j].p)
            if r <= R:
                Merge(i + 1, j + 1)

    id = [-1] * SZ
    cnt = [0] * SZ
    ss = []

    for i in range(len(s)):
        x = Root(i + 1)
        if id[x] == -1:
            cnt[len(ss)] = 1
            id[x] = len(ss)
            ss.append(s[i])
        else:
            cnt[id[x]] += 1
            ss[id[x]].p += s[i].p
            ss[id[x]].v += s[i].v
            ss[id[x]].m += s[i].m

    for i in range(len(ss)):
        ss[i].p /= cnt[i]
        ss[i].v /= cnt[i]
    
    ts = s
    for i in range(len(s)):
        x = Root(i + 1)
        ts[i] = ss[id[x]]
    
    if T % 100 == 0:
        for i in range(len(s)):
            xpt = [ts[i].p[0], ps[i].p[0]]
            ypt = [ts[i].p[1], ps[i].p[1]]
            plt.plot(xpt, ypt, ts[i].col)
        # plt.pause(0.1)
        ps = copy.deepcopy(s)
        
    s = ss
    T += 1

plt.savefig("test.png")