#include<bits/stdc++.h>
using namespace std;
#define ll long long 
struct vec{
    double x,y;
    vec(){x=y=0;}
    vec(double ix,double iy){x=ix,y=iy;}
    inline vec operator+(vec t){return vec(x+t.x,y+t.y);}
    inline vec operator-(vec t){return vec(x-t.x,y-t.y);}
    inline vec cdot(double t){return vec(x*t,y*t);}
    inline double norm(){return sqrt(x*x+y*y);}
};
struct star{
    double m;
    vec p,v;
    bool sta;
    star(){m=0,p=v=vec(),sta=0;}
    star(double im,vec ip,vec iv){m=im,p=ip,v=iv,sta=0;}
};
const int maxn=100;
const double G=6.6743e-11;
const double DT=5;
const double R=1e7;
const double top=4e9;
int n;
int to[maxn+5];
star s[maxn+5];
vec sv[maxn+5];
int cnt[maxn+5];
vector<vec> lst[maxn+5];
signed main(){
    n=3;
    s[1]=star(1e23,vec(0,0),vec(19,0));
    s[2]=star(1e23,vec(2e10,2e10),vec(0,-10));
    s[3]=star(1e23,vec(1e10,5e9),vec(-12,15));
    for(int i=1;i<=n;i++) to[i]=i;
    for(double tim=0;tim<=top;tim++){
        for(int i=1;i<=n;i++) sv[i]=vec();
        for(int i=1;i<=n;i++){
            if(s[i].sta) continue;
            for(int j=1;j<=n;j++){
                if(i==j) continue;
                if(s[j].sta) continue;
                vec d=(s[j].p-s[i].p);
                double r=d.norm();
                double f=G*s[i].m*s[j].m/r/r;
                double a=f/s[i].m;
                sv[i]=sv[i]+d.cdot(a*DT/r);
            }
        }
        for(int i=1;i<=n;i++){
            if(s[i].sta) continue;
            s[i].p=s[i].p+s[i].v.cdot(DT)+sv[i].cdot(DT/2);
            s[i].v=s[i].v+sv[i];
        }
        for(int i=1;i<=n;i++) cnt[i]=0;
        for(int i=1;i<=n;i++){
            if(s[i].sta) continue;
            for(int j=1;j<i;j++){
                if(s[j].sta) continue;
                if((s[j].p-s[i].p).norm()<=R){
                    to[i]=to[j];
                    s[i].sta=1;
                    s[to[i]].m+=s[i].m;
                    s[to[i]].v=s[to[i]].v+s[i].v;
                    s[to[i]].p=s[to[i]].p+s[i].p;
                    cnt[to[i]]++;
                    break;
                }
            }
        }
        for(int i=1;i<=n;i++){
            if(cnt[i]){
                s[i].p=s[i].p.cdot(1.0/cnt[i]);
                s[i].v=s[i].v.cdot(1.0/cnt[i]);
            }
        }
        // printf("%lf\n",(tim+1)*DT);
        // for(int i=1;i<=n;i++)
        //     printf("%d %.3lf %.3lf\n",i,s[i].p.x,s[i].p.y);
        if((ll)(tim)%(ll)(4e3)==0){
            for(int i=1;i<=n;i++){
                if(s[i].sta) continue;
                lst[i].emplace_back(s[i].p);
            }
        }
        if((ll)(tim)%(ll)(top/200)==0)
            cerr<<100.0*tim/top<<"%"<<endl;
    }
    FILE* outf=fopen("data.txt","w");
    fprintf(outf,"%d\n",n);
    for(int i=1;i<=n;i++){
        for(vec t:lst[i]) fprintf(outf,"%.3lf ",t.x);
        fprintf(outf,"\n");
        for(vec t:lst[i]) fprintf(outf,"%.3lf ",t.y);
        fprintf(outf,"\n");
    }
    // system("python3 static.py");
    // system("python3 dynamic.py");
    return 0;
}